package com.acmebank.dao;

import com.acmebank.domain.User;
import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

@Dao
public class DefaultUserDao implements UserDao {

	@PersistenceContext
	private EntityManager entityManager;

	@Override
	public void addUser(User user) {
		entityManager.persist(user);
		// entityManager.flush();
	}

	@Override
	public User getUser(String username) {
		CriteriaBuilder criteriaBuilder = entityManager.getCriteriaBuilder();
		CriteriaQuery<User> criteriaQuery = criteriaBuilder
				.createQuery(User.class);
		Root<User> user = criteriaQuery.from(User.class);
		criteriaQuery.select(user).where(
				criteriaBuilder.equal(user.get("username"), username));

		List<User> users = entityManager.createQuery(criteriaQuery)
				.getResultList();

		if (!users.isEmpty()) {
			return users.get(0);
		} else {
			return null;
		}
	}

	@Override
	public void deleteUser(User user) {
		user = entityManager.merge(user);
		entityManager.remove(user);
		// entityManager.flush();
	}
}
